if exists(select 1 from sysobjects where type='p' and name = 'SP_MUBI_CROSSTABS_ORGRESULT')
  drop procedure SP_MUBI_CROSSTABS_ORGRESULT
go

create procedure SP_MUBI_CROSSTABS_ORGRESULT 
                @query varchar(8000),
                @DelLinZeradas int,
                @DelColZeradas int,
                @OrdenaLinhas int,
                @ValColuna varchar(100), 
                @OrderByAsc int,
                @Formula varchar(3000)
as
begin
  declare @aux2 varchar(3000)
  declare @aux3 varchar(3000)
  declare @s1 varchar(3000)
  declare @s2 varchar(3000)
  declare @i int
  declare @j int
  declare @p1 int
  declare @p2 int

  --TRATA A EXISTNCIA DE FORMULA
  if @Formula <> ''
  begin
    set @formula = ' '+ @formula +' '
    
    --SUBUSTITUIR ^ POR POWER()
    if charindex('^', @formula) > 0
    begin
      set @p1 = 0
      set @p2 = 0
    
      while charindex('^', @formula) > 0
      begin
          set @i = charindex('^', @formula) - 1
          set @aux2 = substring(@formula, @i, 1)
          set @aux3 = ''
          set @j = 0
          while (@i > 0) and ((charindex(@aux2, '+-*/%^') = 0) or (@j <> 0))
          begin
            if @aux2 = ')' 
              set @j = @j + 1
    
            if @aux2 = '(' 
              set @j = @j - 1
    
            set @aux3 = @aux2 + @aux3
    
            set @i = @i - 1
            if @i > 0 
              set @aux2 = substring(@formula, @i, 1)
          end
          set @p1 = @i
          set @s1 = @aux3
    
          set @i = charindex('^', @formula) + 1
          set @aux2 = substring(@formula, @i, 1)
          set @aux3 = ''
          set @j = 0
          while ((charindex(@aux2, '+-*/%^') = 0) or (@j <> 0)) and (@i <= len(@formula))
          begin
            if @aux2 = '(' 
              set @j = @j + 1
    
            if @aux2 = ')' 
              set @j = @j - 1
    
            set @aux3 = @aux3 + @aux2 
    
            set @i = @i + 1
            set @aux2 = substring(@formula, @i, 1)
          end
          set @p2 = @i
          set @s2 = @aux3
    
          set @i = charindex('^', @formula)
          set @formula = left(@formula, @p1) + 'power('+ @s1 +','+ @s2 +')' + substring(@formula, @p2, len(@formula))
      end
    end
    
    --SUBUSTITUIR MOD POR %
    if charindex(' mod ', @formula) > 0
      set @formula = replace(@formula, ' mod ', ' % ')

    --set @query = replace(@query, 'sum(@formula)', @formula)
    --set @query = left(@query, charindex('order by', @query)-1)
  end

  --PROCESSA A QUERY
  if ((@OrdenaLinhas + @DelLinZeradas + @DelColZeradas) > 0) or (@Formula <> '')
  begin
      set nocount on
      
      create table #tmpresult (
        maxvalue float,
        linha varchar(100),
        coluna varchar(100),
        valor float
      )

      if (@Formula = '')
      begin
        set @query = REPLACE(@query,'select ','select 0.0, ')
        insert into #tmpresult execute (@query)
      end
      else
      begin -- SE POSSUI FORMULA
        create table #tmpaux (
          linha varchar(100),
          coluna varchar(100),
          atr1 float,
          atr2 float,
          atr3 float,
          atr4 float,
          atr5 float,
          atr6 float,
          atr7 float,
          atr8 float,
          atr9 float,
          atr10 float
        )

        --Obtem o nome da tabela principal
        set @aux2 = @query
        set @aux2 = substring(@aux2, charindex('from ', @aux2)+5, len(@aux2))
        set @aux2 = ltrim(@aux2)
        set @aux2 = left(@aux2, charindex(' ', @aux2)-1)

        --Monta o insert para a #tmpaux
        set @aux3 = left(@query, charindex(' coluna', @query) + 6) -- ser algo do tipo: 'select l.descricao linha, c.descricao coluna' mas pode variar se optou por atributos
        if exists(select * from sysobjects, syscolumns where sysobjects.id = syscolumns.id and syscolumns.name = 'atr1' and sysobjects.name = @aux2) begin
          set @aux3 = @aux3 + ', isnull(sum(atr1), 0) atr1 '
          if exists(select * from sysobjects, syscolumns where sysobjects.id = syscolumns.id and syscolumns.name = 'atr2' and sysobjects.name = @aux2) begin
            set @aux3 = @aux3 + ', isnull(sum(atr2), 0) atr2 '
            if exists(select * from sysobjects, syscolumns where sysobjects.id = syscolumns.id and syscolumns.name = 'atr3' and sysobjects.name = @aux2) begin
              set @aux3 = @aux3 + ', isnull(sum(atr3), 0) atr3 '
              if exists(select * from sysobjects, syscolumns where sysobjects.id = syscolumns.id and syscolumns.name = 'atr4' and sysobjects.name = @aux2) begin
                set @aux3 = @aux3 + ', isnull(sum(atr4), 0) atr4 '
                if exists(select * from sysobjects, syscolumns where sysobjects.id = syscolumns.id and syscolumns.name = 'atr5' and sysobjects.name = @aux2) begin
                  set @aux3 = @aux3 + ', isnull(sum(atr5), 0) atr5 '
                  if exists(select * from sysobjects, syscolumns where sysobjects.id = syscolumns.id and syscolumns.name = 'atr6' and sysobjects.name = @aux2) begin
                    set @aux3 = @aux3 + ', isnull(sum(atr6), 0) atr6 '
                    if exists(select * from sysobjects, syscolumns where sysobjects.id = syscolumns.id and syscolumns.name = 'atr7' and sysobjects.name = @aux2) begin
                      set @aux3 = @aux3 + ', isnull(sum(atr7), 0) atr7 '
                      if exists(select * from sysobjects, syscolumns where sysobjects.id = syscolumns.id and syscolumns.name = 'atr8' and sysobjects.name = @aux2) begin
                        set @aux3 = @aux3 + ', isnull(sum(atr8), 0) atr8 '
                        if exists(select * from sysobjects, syscolumns where sysobjects.id = syscolumns.id and syscolumns.name = 'atr9' and sysobjects.name = @aux2) begin
                          set @aux3 = @aux3 + ', isnull(sum(atr9), 0) atr9 '
                          if exists(select * from sysobjects, syscolumns where sysobjects.id = syscolumns.id and syscolumns.name = 'atr10' and sysobjects.name = @aux2) 
                            set @aux3 = @aux3 + ', isnull(sum(atr10), 0) atr10 '
                          else
                            set @aux3 = @aux3 + ', 0 '
                        end
                        else
                          set @aux3 = @aux3 + ', 0, 0 '
                      end  
                      else
                        set @aux3 = @aux3 + ', 0, 0, 0 '
                    end
                    else
                      set @aux3 = @aux3 + ', 0, 0, 0, 0 '
                  end  
                  else
                    set @aux3 = @aux3 + ', 0, 0, 0, 0, 0 '
                end
                else
                  set @aux3 = @aux3 + ', 0, 0, 0, 0, 0, 0 '
              end  
              else
                set @aux3 = @aux3 + ', 0, 0, 0, 0, 0, 0, 0 '
            end
            else
              set @aux3 = @aux3 + ', 0, 0, 0, 0, 0, 0, 0, 0 '
          end  
          else
            set @aux3 = @aux3 + ', 0, 0, 0, 0, 0, 0, 0, 0, 0 '
        end
        else
          set @aux3 = @aux3 + ', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 '

        set @aux2 = substring(@query, charindex('from ', @query), len(@query))
        set @aux3 = @aux3 + @aux2

        insert into #tmpaux execute (@aux3)
        insert into #tmpresult execute ('select 0, linha, coluna, '+ @Formula +' from #tmpaux')
      end

      -- PROCESSA A INFORMAO DE RETORNO
      if @OrdenaLinhas = 1 
        update #tmpresult 
        set maxvalue = (select max(tmax.valor) from #tmpresult tmax where tmax.linha = #tmpresult.linha and tmax.coluna = @ValColuna)
    
      if @DelLinZeradas = 1 
        delete #tmpresult where linha in (select linha from #tmpresult group by linha having sum(valor) = 0)
    
      if @DelColZeradas = 1 
        delete #tmpresult where coluna in (select coluna from #tmpresult group by coluna having sum(valor) = 0)

      set nocount off

      if @OrderByAsc = 1 
          select linha, coluna, valor from #tmpresult order by maxvalue asc, linha, coluna
      else
          select linha, coluna, valor from #tmpresult order by maxvalue desc, linha, coluna
  end
  else execute (@query)
end
go


/*****************************************************************************************/

if exists(select 1 from sysobjects where type='p' and name = 'SP_MUBI_CMPDATA')
  drop procedure SP_MUBI_CMPDATA
go

create procedure SP_MUBI_CMPDATA
                @descricao varchar(50),
                @Dimensao int,
                @Metrica varchar(50),
                @Campo4 varchar(500), 
                @Campo5 varchar(500), 
                @DtInicial1 varchar(10),
                @DtFinal1 varchar(10),
                @DtInicial2 varchar(10),
                @DtFinal2 varchar(10),
                @DtInicial3 varchar(10),
                @DtFinal3 varchar(10),
                @SqlFiltro varchar(3000),
                @OrderBy int,
                @OrderByAsc int
as
begin
    set nocount on

    declare @nsql varchar(500)
    declare @tsql varchar(500)
    declare @lastsql varchar(8000)
    declare @periodo1 varchar(100)
    declare @periodo2 varchar(100)
    declare @periodo3 varchar(100)

    set @nsql = ', sum(n.' + @Metrica +') '+ @Metrica
    set @tsql = ', a.' + @Metrica + ' ' + @Metrica + ', case when b.' + @Metrica + ' = 0 then 0 else round((a.' + @Metrica + '*100/b.' + @Metrica + '),2) end p' + @Metrica

    set @periodo1 = ' and n.data between convert(datetime, ''' + @DtInicial1 + ''', 103) and convert(datetime, ''' + @DtFinal1 + ''', 103) '
    set @periodo2 = ' and n.data between convert(datetime, ''' + @DtInicial2 + ''', 103) and convert(datetime, ''' + @DtFinal2 + ''', 103) '
    if (@DtInicial3 is not null) and (@DtFinal3 is not null)
        set @periodo3 = ' and n.data between convert(datetime, ''' + @DtInicial3 + ''', 103) and convert(datetime, ''' + @DtFinal3 + ''', 103) '
    else
        set @periodo3 = null

    create table #tmp_aux1 (
        nivel varchar(50),
        descricao varchar(100),
        metrica float,
        pmetrica float)

    create table #tmp_aux2 (
        nivel varchar(50),
        descricao varchar(100),
        metrica float,
        pmetrica float)

    create table #tmp_aux3 (
        nivel varchar(50),
        descricao varchar(100),
        metrica float,
        pmetrica float)

    create table #tmp_result (
        descricao varchar(100),
        valperiodo1 numeric(10,2),
        valperiodo2 numeric(10,2),
        valperiodo3 numeric(10,2),
        percperiodo1 numeric(10,2),
        percperiodo2 numeric(10,2),
        percperiodo3 numeric(10,2),
        valper21 numeric(10,2),
        valper32 numeric(10,2),
        percper21 numeric(10,2),
        percper32 numeric(10,2))

    If @descricao = 'descricao' begin
        set @lastsql = ' select a.nivel' + ltrim(rtrim(str(@Dimensao))) + ',a.descricao descricao ' + @tsql +
                       ' from (select n.nivel' + ltrim(rtrim(str(@Dimensao))) + ',tn.descricao ' + @nsql +
                             ' from ' + @Campo4 + ' n , ' + @Campo5 + ' tn' +
                             ' where n.nivel' + ltrim(rtrim(str(@Dimensao))) + ' = tn.nivel' + ltrim(rtrim(str(@Dimensao))) + ' '+
                             @periodo1 + @SqlFiltro +
                             ' group by n.nivel' + ltrim(rtrim(str(@Dimensao))) + ',tn.descricao) a,' +
                            ' (select ''%'' perc' + @nsql +
                             ' from ' + @Campo4 + ' n, ' + @Campo5 + ' tn where n.nivel' + ltrim(rtrim(str(@Dimensao))) + ' = tn.nivel' + ltrim(rtrim(str(@Dimensao))) + ' '+
                             @periodo1 + @SqlFiltro + ') b' 
        insert into #tmp_aux1 execute(@lastsql)

        set @lastsql = ' select a.nivel' + ltrim(rtrim(str(@Dimensao))) + ',a.descricao descricao ' + @tsql +
                       ' from (select n.nivel' + ltrim(rtrim(str(@Dimensao))) + ',tn.descricao ' + @nsql +
                             ' from ' + @Campo4 + ' n , ' + @Campo5 + ' tn' +
                             ' where n.nivel' + ltrim(rtrim(str(@Dimensao))) + ' = tn.nivel' + ltrim(rtrim(str(@Dimensao))) + ' '+
                             @periodo2 + @SqlFiltro +
                             ' group by n.nivel' + ltrim(rtrim(str(@Dimensao))) + ',tn.descricao) a,' +
                            ' (select ''%'' perc' + @nsql +
                             ' from ' + @Campo4 + ' n, ' + @Campo5 + ' tn where n.nivel' + ltrim(rtrim(str(@Dimensao))) + ' = tn.nivel' + ltrim(rtrim(str(@Dimensao))) + ' '+
                             @periodo2 + @SqlFiltro + ') b' 
        insert into #tmp_aux2 execute(@lastsql)

        if @periodo3 is not null begin
            set @lastsql = ' select a.nivel' + ltrim(rtrim(str(@Dimensao))) + ',a.descricao descricao ' + @tsql +
                           ' from (select n.nivel' + ltrim(rtrim(str(@Dimensao))) + ',tn.descricao ' + @nsql +
                                 ' from ' + @Campo4 + ' n , ' + @Campo5 + ' tn' +
                                 ' where n.nivel' + ltrim(rtrim(str(@Dimensao))) + ' = tn.nivel' + ltrim(rtrim(str(@Dimensao))) + ' '+
                                 @periodo3 + @SqlFiltro +
                                 ' group by n.nivel' + ltrim(rtrim(str(@Dimensao))) + ',tn.descricao) a,' +
                                ' (select ''%'' perc' + @nsql +
                                 ' from ' + @Campo4 + ' n, ' + @Campo5 + ' tn where n.nivel' + ltrim(rtrim(str(@Dimensao))) + ' = tn.nivel' + ltrim(rtrim(str(@Dimensao))) + ' '+
                                 @periodo3 + @SqlFiltro + ') b' 
            insert into #tmp_aux3 execute(@lastsql)
        end    
    end  
    else begin
        set @lastsql = ' select null, a.' + ltrim(rtrim(@Descricao)) + ' descricao ' + @tsql +
                       ' from (select tn.' + ltrim(rtrim(@Descricao)) + ' ' + @nsql +
                             ' from ' + @Campo4 + ' n, ' + @Campo5 + ' tn' +
                             ' where n.nivel' + ltrim(rtrim(str(@Dimensao))) + ' = tn.nivel' + ltrim(rtrim(str(@Dimensao))) +' '+
                             @periodo1 + @SqlFiltro +
                             ' group by tn.' + ltrim(rtrim(@Descricao)) + ') a,' +
                            ' (select ''%'' perc' + @nsql +
                             ' from ' + @Campo4 + ' n, ' + @Campo5 + ' tn where n.nivel' + ltrim(rtrim(str(@Dimensao))) + ' = tn.nivel' + ltrim(rtrim(str(@Dimensao))) +' '+
                             @periodo1 + @SqlFiltro + ') b' 
        insert into #tmp_aux1 execute(@lastsql)

        set @lastsql = ' select null, a.' + ltrim(rtrim(@Descricao)) + ' descricao ' + @tsql +
                       ' from (select tn.' + ltrim(rtrim(@Descricao)) + ' ' + @nsql +
                             ' from ' + @Campo4 + ' n, ' + @Campo5 + ' tn' +
                             ' where n.nivel' + ltrim(rtrim(str(@Dimensao))) + ' = tn.nivel' + ltrim(rtrim(str(@Dimensao))) + ' '+
                             @periodo2 + @SqlFiltro +
                             ' group by tn.' + ltrim(rtrim(@Descricao)) + ') a,' +
                            ' (select ''%'' perc' + @nsql +
                             ' from ' + @Campo4 + ' n, ' + @Campo5 + ' tn where n.nivel' + ltrim(rtrim(str(@Dimensao))) + ' = tn.nivel' + ltrim(rtrim(str(@Dimensao))) + ' '+
                             @periodo2 + @SqlFiltro + ') b' 
        insert into #tmp_aux2 execute(@lastsql)

        if @periodo3 is not null begin
            set @lastsql = ' select null, a.' + ltrim(rtrim(@Descricao)) + ' descricao ' + @tsql +
                           ' from (select tn.' + ltrim(rtrim(@Descricao)) + ' ' + @nsql +
                                 ' from ' + @Campo4 + ' n, ' + @Campo5 + ' tn' +
                                 ' where n.nivel' + ltrim(rtrim(str(@Dimensao))) + ' = tn.nivel' + ltrim(rtrim(str(@Dimensao))) + ' '+
                                 @periodo3 + @SqlFiltro +
                                 ' group by tn.' + ltrim(rtrim(@Descricao)) + ') a,' +
                                ' (select ''%'' perc' + @nsql +
                                 ' from ' + @Campo4 + ' n, ' + @Campo5 + ' tn where n.nivel' + ltrim(rtrim(str(@Dimensao))) + ' = tn.nivel' + ltrim(rtrim(str(@Dimensao))) + ' '+
                                 @periodo3 + @SqlFiltro + ') b' 
            insert into #tmp_aux3 execute(@lastsql)
        end
    end

    if @periodo3 is null begin
        insert into #tmp_result 
        select isnull(aux1.descricao, aux2.descricao), 
               isnull(aux1.metrica, 0.00), 
               isnull(aux2.metrica, 0.00), 
               null, 
               isnull(aux1.pmetrica, 0.00),
               isnull(aux2.pmetrica, 0.00), 
               null, 
               isnull(aux2.metrica, 0.00) - isnull(aux1.metrica, 0.00),
               null, 
               case when isnull(aux1.metrica, 0) = 0 then null else (((isnull(aux2.metrica, 0.00) - aux1.metrica) *100) /aux1.metrica) end, 
               null
        from #tmp_aux1 aux1 FULL OUTER JOIN #tmp_aux2 aux2 on (aux1.descricao = aux2.descricao)
    end 
    else begin
        insert into #tmp_result 
        select descricao, sum(m1), sum(m2), sum(m3), sum(p1), sum(p2), sum(p3), sum(m2) - sum(m1), sum(m3) - sum(m2),
               case when sum(m1) = 0.00 then null else (((sum(m2) - sum(m1))*100)/sum(m1)) end, 
               case when sum(m2) = 0.00 then null else (((sum(m3) - sum(m2))*100)/sum(m2)) end
        from (select descricao, metrica m1, 0.0 m2, 0.0 m3, pmetrica p1, 0.0 p2, 0.0 p3 from #tmp_aux1
              union
              select descricao, 0.0 m1, metrica m2, 0.0 m3, 0.0 p1, pmetrica p2, 0.0 p3 from #tmp_aux2
              union 
              select descricao, 0.0 m1, 0.0 m2, metrica m3, 0.0 p1, 0.0 p2, pmetrica p3 from #tmp_aux3) aux
        group by descricao
    end

    set nocount off

    if @OrderBy = 1 begin
        if @OrderByAsc = 1
            select * from #tmp_result order by valperiodo1 asc
        else
            select * from #tmp_result order by valperiodo1 desc
    end
    else if @OrderBy = 2 begin
        if @OrderByAsc = 1
            select * from #tmp_result order by valperiodo2 asc
        else
            select * from #tmp_result order by valperiodo2 desc
    end
    else if @OrderBy = 3 begin
        if @OrderByAsc = 1
            select * from #tmp_result order by valperiodo3 asc
        else
            select * from #tmp_result order by valperiodo3 desc
    end

end
go

